Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/OPA_SRC/nemogcm.F90	(revision 6639)
@@ -445,20 +445,64 @@
       !                                     ! Passive tracers
                             CALL     trc_init
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : trc_init OK --  next DIAGNOSTICS -- '
+      CALL flush(numout)
+# endif
 #endif
       !                                     ! Diagnostics
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : Begins Diag inits --  next flo_init if lk_floats -- '
+      CALL flush(numout)
+# endif
       IF( lk_floats     )   CALL     flo_init   ! drifting Floats
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : flo_init OK --  next dia_ar5_init if lk_diaar5 -- '
+      CALL flush(numout)
+# endif
       IF( lk_diaar5     )   CALL dia_ar5_init   ! ar5 diag
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : dia_ar5_init OK --  next dia_ptr_init -- '
+      CALL flush(numout)
+# endif
                             CALL dia_ptr_init   ! Poleward TRansports initialization
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : dia_ptr_init OK --  next dia_dct_init if lk_diadct -- '
+      CALL flush(numout)
+# endif
       IF( lk_diadct     )   CALL dia_dct_init   ! Sections tranports
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : dia_dct_init OK --  next dia_hsb_init -- '
+      CALL flush(numout)
+# endif
                             CALL dia_hsb_init   ! heat content, salt content and volume budgets
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : dia_hsb_init OK --  next trd_init -- '
+      CALL flush(numout)
+# endif
                             CALL     trd_init   ! Mixed-layer/Vorticity/Integral constraints trends
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : trd_init OK --  next dia_obs_init if lk_diaobs -- '
+      CALL flush(numout)
+# endif
       IF( lk_diaobs     ) THEN                  ! Observation & model comparison
                             CALL dia_obs_init            ! Initialize observational data
+# if defined key_debug_medusa
+           IF(lwp) WRITE(numout,*) '--nemo_init : dia_obs_init OK -- dia_obs if lk_diaobs -- '
+           CALL flush(numout)
+# endif
                             CALL dia_obs( nit000 - 1 )   ! Observation operator for restart
       ENDIF
-
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init : dia_obs OK --  next asm_inc_init if lk_asminc -- '
+      CALL flush(numout)
+# endif
       !                                     ! Assimilation increments
       IF( lk_asminc     )   CALL asm_inc_init   ! Initialize assimilation increments
       IF(lwp) WRITE(numout,*) 'Euler time step switch is ', neuler
+      !
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '--nemo_init - Done - OK  -- '
+      CALL flush(numout)
+# endif
       !
    END SUBROUTINE nemo_init
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/C14b/par_c14b.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/C14b/par_c14b.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/C14b/par_c14b.F90	(revision 6639)
@@ -11,4 +11,14 @@
    USE par_pisces , ONLY : jp_pisces_trd   !: number of biological diag in PISCES
 
+   USE par_medusa , ONLY : jp_medusa       !: number of tracers in MEDUSA
+   USE par_medusa , ONLY : jp_medusa_2d    !: number of 2D diag in MEDUSA
+   USE par_medusa , ONLY : jp_medusa_3d    !: number of 3D diag in MEDUSA
+   USE par_medusa , ONLY : jp_medusa_trd   !: number of biological diag in MEDUSA
+
+   USE par_idtra  , ONLY : jp_idtra        !: number of tracers in MEDUSA
+   USE par_idtra  , ONLY : jp_idtra_2d     !: number of tracers in MEDUSA
+   USE par_idtra  , ONLY : jp_idtra_3d     !: number of tracers in MEDUSA
+   USE par_idtra  , ONLY : jp_idtra_trd    !: number of tracers in MEDUSA
+
    USE par_cfc    , ONLY : jp_cfc          !: number of tracers in CFC
    USE par_cfc    , ONLY : jp_cfc_2d       !: number of 2D diag in CFC
@@ -19,8 +29,12 @@
    IMPLICIT NONE
 
-   INTEGER, PARAMETER ::   jp_lb      =  jp_pisces     + jp_cfc     !: cum. number of pass. tracers
-   INTEGER, PARAMETER ::   jp_lb_2d   =  jp_pisces_2d  + jp_cfc_2d  !:
-   INTEGER, PARAMETER ::   jp_lb_3d   =  jp_pisces_3d  + jp_cfc_3d  !:
-   INTEGER, PARAMETER ::   jp_lb_trd  =  jp_pisces_trd + jp_cfc_trd !:
+   INTEGER, PARAMETER ::   jp_lb      =  jp_pisces     + jp_medusa     +   &
+                      jp_idtra      + jp_cfc                               !: cum. number of pass. tracers
+   INTEGER, PARAMETER ::   jp_lb_2d   =  jp_pisces_2d  + jp_medusa_2d  +   &
+                      jp_idtra_2d   + jp_cfc_2d  !:
+   INTEGER, PARAMETER ::   jp_lb_3d   =  jp_pisces_3d  + jp_medusa_3d  +   &
+                      jp_idtra_3d   + jp_cfc_3d  !:
+   INTEGER, PARAMETER ::   jp_lb_trd  =  jp_pisces_trd + jp_medusa_trd +   &
+                      jp_idtra_trd  + jp_cfc_trd !:
    
 #if defined key_c14b
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/par_cfc.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/par_cfc.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/par_cfc.F90	(revision 6639)
@@ -15,10 +15,24 @@
    USE par_pisces , ONLY : jp_pisces_trd   !: number of biological diag in PISCES
 
+   USE par_medusa , ONLY : jp_medusa       !: number of tracers in MEDUSA
+   USE par_medusa , ONLY : jp_medusa_2d    !: number of 2D diag in MEDUSA
+   USE par_medusa , ONLY : jp_medusa_3d    !: number of 3D diag in MEDUSA
+   USE par_medusa , ONLY : jp_medusa_trd   !: number of biological diag in MEDUSA
+
+   USE par_idtra  , ONLY : jp_idtra        !: number of tracers in MEDUSA
+   USE par_idtra  , ONLY : jp_idtra_2d     !: number of tracers in MEDUSA
+   USE par_idtra  , ONLY : jp_idtra_3d     !: number of tracers in MEDUSA
+   USE par_idtra  , ONLY : jp_idtra_trd    !: number of tracers in MEDUSA
+
    IMPLICIT NONE
 
-   INTEGER, PARAMETER ::   jp_lc      =  jp_pisces     !: cumulative number of passive tracers
-   INTEGER, PARAMETER ::   jp_lc_2d   =  jp_pisces_2d  !:
-   INTEGER, PARAMETER ::   jp_lc_3d   =  jp_pisces_3d  !:
-   INTEGER, PARAMETER ::   jp_lc_trd  =  jp_pisces_trd !:
+   INTEGER, PARAMETER ::   jp_lc      =  jp_pisces     + jp_medusa     + &
+                      jp_idtra     !: cumulative number of passive tracers
+   INTEGER, PARAMETER ::   jp_lc_2d   =  jp_pisces_2d  + jp_medusa_2d  + &
+                      jp_idtra_2d !:
+   INTEGER, PARAMETER ::   jp_lc_3d   =  jp_pisces_3d  + jp_medusa_3d  + &
+                      jp_idtra_3d !:
+   INTEGER, PARAMETER ::   jp_lc_trd  =  jp_pisces_trd + jp_medusa_trd + &
+                      jp_idtra_trd !:
    
 #if defined key_cfc
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/CFC/trcsms_cfc.F90	(revision 6639)
@@ -15,4 +15,5 @@
    !!   cfc_init     :  sets constants for CFC surface forcing computation
    !!----------------------------------------------------------------------
+   USE dom_oce       ! ocean space and time domain
    USE oce_trc       ! Ocean variables
    USE par_trc       ! TOP parameters
@@ -176,14 +177,41 @@
          !                                                  !----------------!
       END DO                                                !  end CFC loop  !
-      !
-      IF( lrst_trc ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'trc_sms_cfc : cumulated input function fields written in ocean restart file ',   &
-            &                    'at it= ', kt,' date= ', ndastp
-         IF(lwp) WRITE(numout,*) '~~~~'
-         DO jn = jp_cfc0, jp_cfc1
-            CALL iom_rstput( kt, nitrst, numrtw, 'qint_'//ctrcnm(jn), qint_cfc(:,:,jn) )
-         END DO
-      ENDIF                                            
+         !
+      IF( kt == nittrc000 ) THEN
+         DO jl = 1, jp_cfc   
+             WRITE(NUMOUT,*) ' '
+             WRITE(NUMOUT,*) 'CFC interpolation verification '  !! Jpalm  
+             WRITE(NUMOUT,*) '################################## '
+             WRITE(NUMOUT,*) ' '
+               if (jl.EQ.1) then
+                   WRITE(NUMOUT,*) 'Traceur = CFC11: '
+               elseif (jl.EQ.2) then
+                   WRITE(NUMOUT,*) 'Traceur = CFC12: '
+               endif
+             WRITE(NUMOUT,*) 'nyear    = ', nyear
+             WRITE(NUMOUT,*) 'nmonth   = ', nmonth
+             WRITE(NUMOUT,*) 'iyear_beg= ', iyear_beg
+             WRITE(NUMOUT,*) 'iyear_end= ', iyear_end
+             WRITE(NUMOUT,*) 'p_cfc(iyear_beg)= ',p_cfc(iyear_beg, 1, jl)
+             WRITE(NUMOUT,*) 'p_cfc(iyear_end)= ',p_cfc(iyear_end, 1, jl)
+             WRITE(NUMOUT,*) 'Im1= ',im1
+             WRITE(NUMOUT,*) 'Im2= ',im2
+             WRITE(NUMOUT,*) 'zpp_cfc = ',zpp_cfc
+             WRITE(NUMOUT,*) ' '
+         END DO  
+# if defined key_debug_medusa
+         CALL flush(numout)
+# endif
+      ENDIF
+        !
+      !IF( lrst_trc ) THEN
+      !   IF(lwp) WRITE(numout,*)
+      !   IF(lwp) WRITE(numout,*) 'trc_sms_cfc : cumulated input function fields written in ocean restart file ',   &
+      !      &                    'at it= ', kt,' date= ', ndastp
+      !   IF(lwp) WRITE(numout,*) '~~~~'
+      !   DO jn = jp_cfc0, jp_cfc1
+      !      CALL iom_rstput( kt, nitrst, numrtw, 'qint_'//ctrcnm(jn), qint_cfc(:,:,jn) )
+      !   END DO
+      !ENDIF                                            
       !
       IF( lk_iomput ) THEN
@@ -203,4 +231,8 @@
       END IF
       !
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '   CFC - Check: nn_timing = ', nn_timing
+      CALL flush(numout)
+# endif
       IF( nn_timing == 1 )  CALL timing_stop('trc_sms_cfc')
       !
@@ -254,13 +286,13 @@
       sca(4,2) =  -0.067430
 
-      IF( ln_rsttr ) THEN
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) ' Read specific variables from CFC model '
-         IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
-         !
-         DO jn = jp_cfc0, jp_cfc1
-            CALL iom_get( numrtr, jpdom_autoglo, 'qint_'//ctrcnm(jn), qint_cfc(:,:,jn) ) 
-         END DO
-      ENDIF
+      !IF( ln_rsttr ) THEN
+      !   IF(lwp) WRITE(numout,*)
+      !   IF(lwp) WRITE(numout,*) ' Read specific variables from CFC model '
+      !   IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+      !   !
+      !   DO jn = jp_cfc0, jp_cfc1
+      !      CALL iom_get( numrtr, jpdom_autoglo, 'qint_'//ctrcnm(jn), qint_cfc(:,:,jn) ) 
+      !   END DO
+      !ENDIF
       IF(lwp) WRITE(numout,*)
       !
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/par_idtra.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/par_idtra.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/par_idtra.F90	(revision 6639)
@@ -21,12 +21,10 @@
    USE par_medusa , ONLY : jp_medusa_trd   !: number of biological diag in MEDUSA
 
+   IMPLICIT NONE
 
-   IMPLICIT NONE
-   PUBLIC
-
-   INTEGER, PUBLIC, PARAMETER ::   jp_lp      =  jp_pisces     + jp_medusa     !: cumulative number of passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_lp_2d   =  jp_pisces_2d  + jp_medusa_2d  !:
-   INTEGER, PUBLIC, PARAMETER ::   jp_lp_3d   =  jp_pisces_3d  + jp_medusa_3d  !:
-   INTEGER, PUBLIC, PARAMETER ::   jp_lp_trd  =  jp_pisces_trd + jp_medusa_trd !:
+   INTEGER, PARAMETER ::   jp_lp      =  jp_pisces     +  jp_medusa     !: cumulative number of passive tracers
+   INTEGER, PARAMETER ::   jp_lp_2d   =  jp_pisces_2d  +  jp_medusa_2d  !:
+   INTEGER, PARAMETER ::   jp_lp_3d   =  jp_pisces_3d  +  jp_medusa_3d  !:
+   INTEGER, PARAMETER ::   jp_lp_trd  =  jp_pisces_trd +  jp_medusa_trd !:
 
 #if defined key_idtra
@@ -36,5 +34,5 @@
    LOGICAL, PUBLIC, PARAMETER ::   lk_idtra     = .TRUE.      !: IDEAL-TRACER flag
    INTEGER, PUBLIC, PARAMETER ::   jp_idtra     =  1          !: number of passive tracers
-   INTEGER, PUBLIC, PARAMETER ::   jp_idtra_2d  =  0          !: additional 2d output arrays ('key_trc_diaadd')
+   INTEGER, PUBLIC, PARAMETER ::   jp_idtra_2d  =  3          !: additional 2d output arrays ('key_trc_diaadd')
    INTEGER, PUBLIC, PARAMETER ::   jp_idtra_3d  =  0          !: additional 3d output arrays ('key_trc_diaadd')
    INTEGER, PUBLIC, PARAMETER ::   jp_idtra_trd =  0          !: number of sms trends for IDEAL-TRACER
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcice_idtra.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcice_idtra.F90	(revision 6639)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcice_idtra.F90	(revision 6639)
@@ -0,0 +1,53 @@
+MODULE trcice_idtra
+   !!======================================================================
+   !!                         ***  MODULE trcice_idtra  ***
+   !! TOP :   Main module of the MY_TRC tracers
+   !!======================================================================
+   !! History :   2.0  !  2007-12  (C. Ethe, G. Madec) Original code
+   !!----------------------------------------------------------------------
+#if defined key_idtra
+   !!----------------------------------------------------------------------
+   !!   'key_idtra'                                    IDEAL TRACER tracers
+   !!----------------------------------------------------------------------
+   !! trc_ice_idtra       : MY_TRC model main routine
+   !!----------------------------------------------------------------------
+   USE par_trc         ! TOP parameters
+   USE oce_trc         ! Ocean variables
+   USE trc             ! TOP variables
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   trc_ice_ini_idtra       ! called by trcice.F90 module
+
+   !!----------------------------------------------------------------------
+   !! NEMO/TOP 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE trc_ice_ini_idtra
+      !!----------------------------------------------------------------------
+      !!                     ***  trc_ice_idtra  ***
+      !!
+      !! ** Purpose :   main routine of MY_TRC model
+      !!
+      !! ** Method  : -
+      !!----------------------------------------------------------------------
+      !
+      !
+   END SUBROUTINE trc_ice_ini_idtra
+
+
+#else
+   !!----------------------------------------------------------------------
+   !!   Dummy module                                        No MY_TRC model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE trc_ice_ini_idtra             ! Empty routine
+   END SUBROUTINE trc_ice_ini_idtra
+#endif
+
+   !!======================================================================
+END MODULE trcice_idtra
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcini_idtra.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcini_idtra.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcini_idtra.F90	(revision 6639)
@@ -16,8 +16,8 @@
    USE trc             ! TOP variables
    USE trcsms_idtra    ! IDEAL-TRACER sms trends
-   USE par_idtra       ! IDEAL-TRACER parameters
-   USE in_out_manager  ! I/O manager
-   USE lib_mpp
-   USE iom
+   ! USE par_idtra       ! IDEAL-TRACER parameters
+   ! USE in_out_manager  ! I/O manager
+   ! USE lib_mpp
+   ! USE iom
 
    IMPLICIT NONE
@@ -46,13 +46,23 @@
       !!----------------------------------------------------------------------
 
+      IF(lwp) WRITE(numout,*)
+      IF(lwp) WRITE(numout,*) ' trc_ini_idtra: initialisation of Ideal Tracers model'
+      IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~'
+
+      IF( trc_sms_idtra_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'trc_ini_idtra:unable to allocate CFC arrays' )
+
 
       ! Initialization of trn in case of  no restart
       !----------------------------------------------
+      qtr_idtra(:,:,:) = 0._wp
+      inv_idtra(:,:,:) = 0._wp
       IF( .NOT. ln_rsttr ) THEN
          IF(lwp) THEN
             WRITE(numout,*)
-            WRITE(numout,*) 'Initialization de id-tracers ; No restart : '
+            WRITE(numout,*) 'Initialization of id-tracers ; No restart : '
             WRITE(numout,*) '                             ; Init field equal 1 at surface - zero elsewhere'
+            WRITE(numout,*) '                             ; qint idtra equal 0 '
          ENDIF
+         qint_idtra(:,:,:) = 0._wp
          DO jn = jp_idtra0, jp_idtra1
              trn(:,:,:,jn) = 0.e0
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcnam_idtra.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcnam_idtra.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcnam_idtra.F90	(revision 6639)
@@ -15,6 +15,6 @@
    USE par_trc         ! TOP parameters
    USE trc             ! TOP variables
-   USE trcsms_idtra      ! IDEAL-TRACER specific variable
-   USE in_out_manager  ! I/O manager
+   USE trcsms_idtra    ! IDEAL-TRACER specific variable
+   USE iom             ! I/O manager
 
    IMPLICIT NONE
@@ -42,28 +42,21 @@
       !! ** input   :   Namelist namidtra
       !!----------------------------------------------------------------------
-      REAL(wp) ::   tmp_decay          !! Years ; half time decay of our idealize tracer
-      REAL(wp) ::   TDECyr, TDEC   
-      CHARACTER(LEN=32)   ::   clname
-      !! 
+      INTEGER  :: numnatm_ref = -1   ! Logical unit for reference ID-TRA namelist
+      INTEGER  :: numnatm_cfg = -1   ! Logical unit for configuration ID-TRA namelist
+      INTEGER  :: numonc      = -1   ! Logical unit for output namelist
+      INTEGER  :: ios                 ! Local integer output status for namelist read
+      REAL(wp) :: tmp_decay          !! Years ; half time decay of our idealize tracer
+      REAL(wp) :: TDECyr, TDEC   
+      !! ----------------------------------------------------------------
       NAMELIST/namidtra/tmp_decay
-!! #if defined key_trc_diaadd
-!!      ! definition of additional diagnostic as a structure
-!!      INTEGER :: jl, jn
-!!
-!! #endif
-      !!
-
-!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-!! Jpalm -- 4-11-2014
-!! namelist for idealize tracer
-!! only thing in namelist is the chosen half time decay
-!! no atmospheric conditions, cause we do impose a surface concentration of 1,
-!! and no additionnal diagnostics, 
-!! because the only thing we are interested in is the water mass concentration on this tracer.
-!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-
-
+      !!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
+      !! Jpalm -- 4-11-2014
+      !! namelist for idealize tracer
+      !! only thing in namelist is the chosen half time decay
+      !! no atmospheric conditions, cause we do impose a surface concentration of 1,
+      !! and no additionnal diagnostics, 
+      !! because the only thing we are interested in is the water mass concentration on this tracer.
+      !!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       IF(lwp) WRITE(numout,*)
-      clname = 'namelist_idtra'
       IF(lwp) WRITE(numout,*) ' trc_nam_idtra: read IDEAL-TRACER namelist'
       IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
@@ -71,6 +64,7 @@
       !! Open the namelist file :
       !!~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-      CALL ctl_opn( numnatm, TRIM( clname ), 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
-
+      CALL ctl_opn( numnatm_ref, 'namelist_idtra_ref', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+      CALL ctl_opn( numnatm_cfg, 'namelist_idtra_cfg', 'OLD', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
+      IF(lwm) CALL ctl_opn( numonc, 'output.namelist.idtra', 'UNKNOWN', 'FORMATTED', 'SEQUENTIAL', -1, numout, .FALSE. )
       !! Read the namelists :
       !!~~~~~~~~~~~~~~~~~~~~~~~
@@ -79,5 +73,13 @@
       !! tmp_decay = 1y ; 10y ; 100y or 1000y depending of which water mass you want to track
       !!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-      READ(numnatm,namidtra)
+
+      REWIND( numnatm_ref )              ! Namelist namidtra in reference namelist : IDTRA parameters
+      READ  ( numnatm_ref, namidtra, IOSTAT = ios, ERR = 901)
+901   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namidtra in reference namelist', lwp )
+
+      REWIND( numnatm_cfg )              ! Namelist namidtra in configuration namelist : IDTRA parameters
+      READ  ( numnatm_cfg, namidtra, IOSTAT = ios, ERR = 902 )
+902   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namidtra in configuration namelist', lwp )
+      IF(lwm) WRITE ( numonc, namidtra )
 
       IF(lwp) WRITE(numout,*) '   -  half time decay of our idealize tracer : ', tmp_decay
Index: branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcsms_idtra.F90
===================================================================
--- branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcsms_idtra.F90	(revision 6638)
+++ branches/UKMO/dev_r5518_RH_MEDUSA_Stable/NEMOGCM/NEMO/TOP_SRC/IDTRA/trcsms_idtra.F90	(revision 6639)
@@ -18,5 +18,5 @@
    USE par_trc      ! TOP parameters
    USE trc          ! TOP variables
-   USE trdtrc_oce
+   USE trd_oce
    USE trdtrc
    USE iom
@@ -25,10 +25,15 @@
    PRIVATE
 
-   PUBLIC   trc_sms_idtra       ! called in ???
-
+   PUBLIC   trc_sms_idtra        ! called in ???
+   PUBLIC   trc_sms_idtra_alloc  ! called in ???
+   !
    INTEGER , PUBLIC    ::   nyear_res      ! restoring time constant (year)
    INTEGER , PUBLIC    ::   numnatm
-
    REAL(wp), PUBLIC    ::   FDEC
+   !
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qtr_idtra  ! flux at surface
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   qint_idtra ! cumulative flux 
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) ::   inv_idtra  ! vertic. inventory
+
    !                          ! coefficients for conversion
    REAL(wp) ::  WTEMP
@@ -69,28 +74,53 @@
       !!              
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt    ! ocean time-step index
-      !!
-      INTEGER ::   ji, jj, jn, jl, jk
-
-
-
-      !!----------------------------------------------------------------------
-      IF(lwp) WRITE(numout,*) '   - JPALM - verif :'
-      IF(lwp) WRITE(numout,*) '   ~~~~~~~~~~~~~~~~~'
-      IF(lwp) WRITE(numout,*) '   - idtra decay factor : ', FDEC
-
+      INTEGER, INTENT( in )  ::   kt    ! ocean time-step index
+      !!
+      INTEGER                ::   ji, jj, jn, jl, jk
+      REAL(wp)               ::   rlx                 !! relaxation time (1 day)
+      !!----------------------------------------------------------------------
+      !
+      IF( nn_timing == 1 )  CALL timing_start('trc_sms_idtra')
+      !
+      rlx = 10./(60. * 60. * 24.)                              !! relaxation time (1/10 day)
+      IF (kt == nittrc000) THEN
+         IF(lwp) WRITE(numout,*) '   trcsms_idtra :'
+         IF(lwp) WRITE(numout,*) '   ~~~~~~~~~~~~~~~~~'
+         IF(lwp) WRITE(numout,*) '   - idtra decay factor : ', FDEC
+         IF(lwp) WRITE(numout,*) '   - relaxation time    : ', rlx
+# if defined key_debug_medusa
+         CALL flush(numout)
+# endif
+      !   CALL idtra_init
+      ENDIF
 
          !
-DO jn = jp_idtra0, jp_idtra1
-
-        ! DO jj = 1, jpj
-        !    DO ji = 1, jpi
-               ! Surface concentrarion fixed to 1 (ideal tracer concentration unit)
-               trn(:,:,1,jn) = 1.
-               trb(:,:,1,jn) = 1.
-               !
-        !    ENDDO
-        ! ENDDO
-
+      inv_idtra(:,:,:) = 0.0                                   !! init the inventory
+      qtr_idtra(:,:,:) = 0.0                                   !! init the air-sea flux
+      DO jl = 1, jp_idtra
+         jn = jp_idtra0 + jl - 1
+
+      !!   DO jj = 1, jpj
+      !!      DO ji = 1, jpi
+           DO jj = 2,jpjm1
+              DO ji = 2,jpim1
+
+         !! First, a crude version. will be much inproved later.
+             qtr_idtra(ji,jj,jl)  = rlx * (1. - trb(ji,jj,1,jn)) * tmask(ji,jj,1) *   & 
+                                  fse3t(ji,jj,1)                  !! Air-sea Flux
+
+           !! DEBUG-TEST : Set flux equal to 0, see if it induces the pb we see in the MED  
+           !!  qtr_idtra(ji,jj,jl)  = 0.0
+           ENDDO
+         ENDDO
+         tra(:,:,1,jn)      = tra(:,:,1,jn) + ( qtr_idtra(:,:,jl) *  &
+                            tmask(:,:,1) / fse3t(:,:,1) )
+         qint_idtra(:,:,jl) = qint_idtra(:,:,jl) +                   &           
+                              qtr_idtra(:,:,jl) * rdt              !! Cumulative Air-sea Flux
+
+
+         DO jk =1,jpk
+            inv_idtra(:,:,jl) = inv_idtra(:,:,jl) +                  &
+                     (trn(:,:,jk,jn) * fse3t(:,:,jk) * tmask(:,:,jk))  !! vertical inventory
+         ENDDO
 !
 !DECAY of OUR IDEALIZED TRACER
@@ -98,9 +128,13 @@
 
          DO  jk =1,jpk
-            DO jj=1,jpj
-              DO  ji =1,jpi
+      !!      DO jj=1,jpj
+      !!        DO  ji =1,jpi
+            DO jj = 2,jpjm1
+               DO ji = 2,jpim1
+            
                !  IF (trn(ji,jj,jk,jn) > 0.0) THEN
                     WTEMP = trn(ji,jj,jk,jn) * (1. - FDEC )
-                    tra(ji,jj,jk,jn) = tra(ji,jj,jk,jn) - WTEMP/rdt
+                    tra(ji,jj,jk,jn) = (tra(ji,jj,jk,jn) - WTEMP/rdt ) * &
+                                     tmask(ji,jj,jk)
                !  ENDIF 
               ENDDO 
@@ -108,32 +142,104 @@
          ENDDO
 
-ENDDO
+      ENDDO
     !! jn loop
 !
-
-!!!!!! No added diagnostics to save here for idealize tracers...
-!!%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
-!! #if defined key_trc_diaadd
-!!       ! Save diagnostics , just for TRI111
-!! # if ! defined key_iomput
-!!       trc2d(:,:,jp_idtra0_2d    ) = zpp_idtra(:,:)
-!! # else
-!! !           WRITE(NUMOUT,*) 'Iomput idtrasurf '
-!!       CALL iom_put( "TRISURF"  , zpp_idtra(:,:) )
-!! !      CALL iom_put( "TRISURF"  , xphem(:,:) )
-!! !           WRITE(NUMOUT,*) 'Iomputage '
-!!        CALL iom_put( "AGE"  , zage(:,:,:) )
-!! # endif
-!! #endif
-!!
-
-!!      IF( l_trdtrc ) THEN
-!!          DO jn = jp_idtra0, jp_idtra1
-!!            zidtradtra(:,:,:) = tra(:,:,:,jn)
-!!            CALL trd_mod_trc( zidtradtra, jn, jptrc_trd_sms, kt )   ! save trends
-!!          END DO
-!!      END IF
-
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) '   IDTRA - calculation part - DONE trc_sms_idtra -- '
+      CALL flush(numout)
+# endif
+        !
+        !! restart and diagnostics management -- 
+      !IF( lrst_trc ) THEN
+      !   IF(lwp) WRITE(numout,*)
+      !   IF(lwp) WRITE(numout,*) 'trc_sms_idtra : cumulated input function fields written in ocean restart file ',   &
+      !      &                    'at it= ', kt,' date= ', ndastp
+      !   IF(lwp) WRITE(numout,*) '~~~~'
+      !   !!DO jn = jp_idtra0, jp_idtra1
+      !      CALL iom_rstput( kt, nitrst, numrtw, 'qint_IDTRA', qint_idtra(:,:,1) )
+      !   !!END DO
+ ! if defined key_debug_medusa
+      !   IF(lwp) WRITE(numout,*) '   IDTRA - writing diag-restart - DONE trc_sms_idtra -- '
+      !   CALL flush(numout)
+ ! endif
+      !ENDIF
+      !
+      IF( lk_iomput ) THEN
+         CALL iom_put( "qtrIDTRA"  , qtr_idtra (:,:,1) )
+         CALL iom_put( "qintIDTRA" , qint_idtra(:,:,1) )
+         CALL iom_put( "invIDTRA" , inv_idtra(:,:,1) )
+      ELSE
+         IF( ln_diatrc ) THEN
+            trc2d(:,:,jp_idtra0_2d    ) = qtr_idtra (:,:,1)
+            trc2d(:,:,jp_idtra0_2d + 1) = qint_idtra(:,:,1)
+            trc2d(:,:,jp_idtra0_2d + 2) = inv_idtra(:,:,1)
+         END IF
+      END IF
+      !
+# if defined key_debug_medusa
+      IF(lwp) WRITE(numout,*) '   IDTRA - writing diag - DONE trc_sms_idtra -- '
+      CALL flush(numout)
+# endif
+      !
+      IF( l_trdtrc ) THEN
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) '   IDTRA - writing trends - trc_sms_idtra -- '
+         CALL flush(numout)
+# endif
+          DO jn = jp_idtra0, jp_idtra1
+            CALL trd_trc( tra(:,:,:,jn), jn, jptra_sms, kt )   ! save trends
+          END DO
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) '   IDTRA - writing trends - DONE trc_sms_idtra -- '
+         CALL flush(numout)
+# endif
+      END IF
+      !
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) '   IDTRA - Check: nn_timing = ', nn_timing 
+         CALL flush(numout)
+# endif
+      IF( nn_timing == 1 )  CALL timing_stop('trc_sms_idtra')
+      !
+# if defined key_debug_medusa
+         IF(lwp) WRITE(numout,*) '   IDTRA DONE trc_sms_idtra -- '
+      CALL flush(numout)
+# endif
+      !
    END SUBROUTINE trc_sms_idtra
+
+   SUBROUTINE idtra_init
+      !!---------------------------------------------------------------------
+      !!                     ***  idtra_init  ***
+      !!
+      !! ** Purpose : read restart values for IDTRA model
+      !!---------------------------------------------------------------------
+      INTEGER :: jn
+
+      IF( ln_rsttr ) THEN
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) ' Read specific variables from Ideal Tracers model '
+         IF(lwp) WRITE(numout,*) ' ~~~~~~~~~~~~~~'
+         !
+         DO jn = jp_idtra0, jp_idtra1
+            CALL iom_get( numrtr, jpdom_autoglo, 'qint_IDTRA', qint_idtra(:,:,jn) )
+         END DO
+      ENDIF
+      IF(lwp) WRITE(numout,*) 'idtra restart variables read -- OK'
+      !
+   END SUBROUTINE idtra_init
+
+   INTEGER FUNCTION trc_sms_idtra_alloc()
+      !!----------------------------------------------------------------------
+      !!                     ***  ROUTINE trc_sms_idtra_alloc  ***
+      !!----------------------------------------------------------------------
+      ALLOCATE( qtr_idtra (jpi,jpj,jp_idtra) ,     &
+         &      inv_idtra(jpi,jpj,jp_idtra)  ,     &
+         &      qint_idtra(jpi,jpj,jp_idtra) , STAT=trc_sms_idtra_alloc )
+         !
+      IF( trc_sms_idtra_alloc /= 0 ) CALL ctl_warn('trc_sms_idtra_alloc : failed to allocate arrays.')
+      !
+   END FUNCTION trc_sms_idtra_alloc
+
 #else
    !!----------------------------------------------------------------------
